﻿Type=Class
Version=4.19
ModulesStructureVersion=1
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private texts As List
	Private lastItem As JavaObject
	Private mModule As Object
	Private mEventName As String
End Sub

Public Sub Initialize
	texts.Initialize
End Sub

Public Sub AddText(text As String) As TextFlow
	Dim lastItem As JavaObject
	lastItem.InitializeNewInstance("javafx.scene.text.Text", Array(text))
	texts.Add(lastItem)
	Return Me
End Sub

Public Sub SetFont(Font As Font) As TextFlow
	lastItem.RunMethod("setFont", Array(Font))
	Return Me
End Sub

Public Sub SetColor(Color As Paint) As TextFlow
	lastItem.RunMethod("setFill", Array(Color))
	Return Me	
End Sub

Public Sub SetUnderline(Underline As Boolean) As TextFlow
	lastItem.RunMethod("setUnderline", Array(Underline))
	Return Me
End Sub

Public Sub SetStrikethrough(Strikethrough As Boolean) As TextFlow
	lastItem.RunMethod("setStrikethrough", Array(Strikethrough))
	Return Me
End Sub

'Hyperlink additions
#Region Hyperlink additions
Public Sub AddHyperlink(Text As String) As Node
	Dim HL As JavaObject
	HL.InitializeNewInstance("javafx.scene.control.Hyperlink",Array(Text))
	texts.Add(HL)
	Dim E As Object = HL.CreateEvent("javafx.event.EventHandler","HyperlinkClicked","")
	HL.RunMethod("setOnAction",Array(E))
	Return HL
End Sub

Public Sub AddHyperlink2(Text As String,Graphic As Node) As Node
	Dim HL As JavaObject
	HL.InitializeNewInstance("javafx.scene.control.Hyperlink",Array(Text,Graphic))
	texts.Add(HL)
	Dim E As Object = HL.CreateEvent("javafx.event.EventHandler","HyperlinkClicked","")
	HL.RunMethod("setOnAction",Array(E))
	Return HL
End Sub

Public Sub SetHyperlinkCallback(Module As Object,EventName As String)
	mModule = Module
	mEventName = EventName
End Sub

Public Sub HyperLinkClicked_Event (MethodName As String, Args() As Object) As Object			'ignore
	Dim HL As JavaObject = Sender
	If mEventName = "" Then
		Log($"Hyperlink '${HL.RunMethod("getText",Null)}' clicked but callback not set"$)
		Return																					'ignore
	End If
	If SubExists(mModule,mEventName & "_Clicked") Then
		CallSub2(mModule,mEventName & "_Clicked",HL.RunMethod("getText",Null))
	End If
End Sub
#End Region Hyperlink Additions


Public Sub CreateTextFlow As Pane
	Dim tf As JavaObject
	tf.InitializeNewInstance("javafx.scene.text.TextFlow", Null)
	tf.RunMethodJO("getChildren", Null).RunMethod("addAll", Array(texts))
	Return tf
End Sub